org.gjt.sp.jedit.bsh.org.objectweb.asm

## Interface CodeVisitor

- All Known Implementing Classes:
    CodeWriter

      public interface CodeVisitor

  A visitor to visit the bytecode instructions of a Java method. The methods of this visitor must be called in the sequential order of the bytecode instructions of the visited code. The `visitMaxs` method must be called after all the instructions have been visited. The `visitTryCatchBlock`, `visitLocalVariable` and `visitLineNumber` methods may be called in any order, at any time (provided the labels passed as arguments have already been visited with `visitLabel`).

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `visitFieldInsn(int opcode, java.lang.String owner, java.lang.String name, java.lang.String desc)` Visits a field instruction.
    `void` | `visitIincInsn(int var, int increment)` Visits an IINC instruction.
    `void` | `visitInsn(int opcode)` Visits a zero operand instruction.
    `void` | `visitIntInsn(int opcode, int operand)` Visits an instruction with a single int operand.
    `void` | `visitJumpInsn(int opcode, Label label)` Visits a jump instruction.
    `void` | `visitLabel(Label label)` Visits a label.
    `void` | `visitLdcInsn(java.lang.Object cst)` Visits a LDC instruction.
    `void` | `visitLineNumber(int line, Label start)` Visits a line number declaration.
    `void` | `visitLocalVariable(java.lang.String name, java.lang.String desc, Label start, Label end, int index)` Visits a local variable declaration.
    `void` | `visitLookupSwitchInsn(Label dflt, int[] keys, Label[] labels)` Visits a LOOKUPSWITCH instruction.
    `void` | `visitMaxs(int maxStack, int maxLocals)` Visits the maximum stack size and the maximum number of local variables of the method.
    `void` | `visitMethodInsn(int opcode, java.lang.String owner, java.lang.String name, java.lang.String desc)` Visits a method instruction.
    `void` | `visitMultiANewArrayInsn(java.lang.String desc, int dims)` Visits a MULTIANEWARRAY instruction.
    `void` | `visitTableSwitchInsn(int min, int max, Label dflt, Label[] labels)` Visits a TABLESWITCH instruction.
    `void` | `visitTryCatchBlock(Label start, Label end, Label handler, java.lang.String type)` Visits a try catch block.
    `void` | `visitTypeInsn(int opcode, java.lang.String desc)` Visits a type instruction.
    `void` | `visitVarInsn(int opcode, int var)` Visits a local variable instruction.

- - ### Method Detail

    - #### visitInsn

          void visitInsn(int opcode)

      Visits a zero operand instruction.
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either NOP, ACONST_NULL, ICONST_M1, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, LCONST_0, LCONST_1, FCONST_0, FCONST_1, FCONST_2, DCONST_0, DCONST_1, IALOAD, LALOAD, FALOAD, DALOAD, AALOAD, BALOAD, CALOAD, SALOAD, IASTORE, LASTORE, FASTORE, DASTORE, AASTORE, BASTORE, CASTORE, SASTORE, POP, POP2, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, SWAP, IADD, LADD, FADD, DADD, ISUB, LSUB, FSUB, DSUB, IMUL, LMUL, FMUL, DMUL, IDIV, LDIV, FDIV, DDIV, IREM, LREM, FREM, DREM, INEG, LNEG, FNEG, DNEG, ISHL, LSHL, ISHR, LSHR, IUSHR, LUSHR, IAND, LAND, IOR, LOR, IXOR, LXOR, I2L, I2F, I2D, L2I, L2F, L2D, F2I, F2L, F2D, D2I, D2L, D2F, I2B, I2C, I2S, LCMP, FCMPL, FCMPG, DCMPL, DCMPG, IRETURN, LRETURN, FRETURN, DRETURN, ARETURN, RETURN, ARRAYLENGTH, ATHROW, MONITORENTER, or MONITOREXIT.

    - #### visitIntInsn

          void visitIntInsn(int opcode,
                            int operand)

      Visits an instruction with a single int operand.
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either BIPUSH, SIPUSH or NEWARRAY.
        `operand` - the operand of the instruction to be visited.

    - #### visitVarInsn

          void visitVarInsn(int opcode,
                            int var)

      Visits a local variable instruction. A local variable instruction is an instruction that loads or stores the value of a local variable.
      Parameters:
        `opcode` - the opcode of the local variable instruction to be visited. This opcode is either ILOAD, LLOAD, FLOAD, DLOAD, ALOAD, ISTORE, LSTORE, FSTORE, DSTORE, ASTORE or RET.
        `var` - the operand of the instruction to be visited. This operand is the index of a local variable.

    - #### visitTypeInsn

          void visitTypeInsn(int opcode,
                             java.lang.String desc)

      Visits a type instruction. A type instruction is an instruction that takes a type descriptor as parameter.
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either NEW, ANEWARRAY, CHECKCAST or INSTANCEOF.
        `desc` - the operand of the instruction to be visited. This operand is must be a fully qualified class name in internal form, or the type descriptor of an array type (see `Type`).

    - #### visitFieldInsn

          void visitFieldInsn(int opcode,
                              java.lang.String owner,
                              java.lang.String name,
                              java.lang.String desc)

      Visits a field instruction. A field instruction is an instruction that loads or stores the value of a field of an object.
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either GETSTATIC, PUTSTATIC, GETFIELD or PUTFIELD.
        `owner` - the internal name of the field's owner class (see `getInternalName`).
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).

    - #### visitMethodInsn

          void visitMethodInsn(int opcode,
                               java.lang.String owner,
                               java.lang.String name,
                               java.lang.String desc)

      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).

    - #### visitJumpInsn

          void visitJumpInsn(int opcode,
                             Label label)

      Visits a jump instruction. A jump instruction is an instruction that may jump to another instruction.
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either IFEQ, IFNE, IFLT, IFGE, IFGT, IFLE, IF_ICMPEQ, IF_ICMPNE, IF_ICMPLT, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ACMPEQ, IF_ACMPNE, GOTO, JSR, IFNULL or IFNONNULL.
        `label` - the operand of the instruction to be visited. This operand is a label that designates the instruction to which the jump instruction may jump.

    - #### visitLabel

          void visitLabel(Label label)

      Visits a label. A label designates the instruction that will be visited just after it.
      Parameters:
        `label` - a `Label` object.

    - #### visitLdcInsn

          void visitLdcInsn(java.lang.Object cst)

      Visits a LDC instruction.
      Parameters:
        `cst` - the constant to be loaded on the stack. This parameter must be a non null `Integer`, a `Float`, a `Long`, a `Double` or a `String`.

    - #### visitIincInsn

          void visitIincInsn(int var,
                             int increment)

      Visits an IINC instruction.
      Parameters:
        `var` - index of the local variable to be incremented.
        `increment` - amount to increment the local variable by.

    - #### visitTableSwitchInsn

          void visitTableSwitchInsn(int min,
                                    int max,
                                    Label dflt,
                                    Label[] labels)

      Visits a TABLESWITCH instruction.
      Parameters:
        `min` - the minimum key value.
        `max` - the maximum key value.
        `dflt` - beginning of the default handler block.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `min + i` key.

    - #### visitLookupSwitchInsn

          void visitLookupSwitchInsn(Label dflt,
                                     int[] keys,
                                     Label[] labels)

      Visits a LOOKUPSWITCH instruction.
      Parameters:
        `dflt` - beginning of the default handler block.
        `keys` - the values of the keys.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `keys[i]` key.

    - #### visitMultiANewArrayInsn

          void visitMultiANewArrayInsn(java.lang.String desc,
                                       int dims)

      Visits a MULTIANEWARRAY instruction.
      Parameters:
        `desc` - an array type descriptor (see `Type`).
        `dims` - number of dimensions of the array to allocate.

    - #### visitTryCatchBlock

          void visitTryCatchBlock(Label start,
                                  Label end,
                                  Label handler,
                                  java.lang.String type)

      Visits a try catch block.
      Parameters:
        `start` - beginning of the exception handler's scope (inclusive).
        `end` - end of the exception handler's scope (exclusive).
        `handler` - beginning of the exception handler's code.
        `type` - internal name of the type of exceptions handled by the handler, or `null` to catch any exceptions (for "finally" blocks).
      Throws:
        `java.lang.IllegalArgumentException` - if one of the labels has not already been visited by this visitor (by the `visitLabel` method).

    - #### visitMaxs

          void visitMaxs(int maxStack,
                         int maxLocals)

      Visits the maximum stack size and the maximum number of local variables of the method.
      Parameters:
        `maxStack` - maximum stack size of the method.
        `maxLocals` - maximum number of local variables for the method.

    - #### visitLocalVariable

          void visitLocalVariable(java.lang.String name,
                                  java.lang.String desc,
                                  Label start,
                                  Label end,
                                  int index)

      Visits a local variable declaration.
      Parameters:
        `name` - the name of a local variable.
        `desc` - the type descriptor of this local variable.
        `start` - the first instruction corresponding to the scope of this local variable (inclusive).
        `end` - the last instruction corresponding to the scope of this local variable (exclusive).
        `index` - the local variable's index.
      Throws:
        `java.lang.IllegalArgumentException` - if one of the labels has not already been visited by this visitor (by the `visitLabel` method).

    - #### visitLineNumber

          void visitLineNumber(int line,
                               Label start)

      Visits a line number declaration.
      Parameters:
        `line` - a line number. This number refers to the source file from which the class was compiled.
        `start` - the first instruction corresponding to this line number.
      Throws:
        `java.lang.IllegalArgumentException` - if `start` has not already been visited by this visitor (by the `visitLabel` method).